﻿Imports System.Math

Public Class frmDebug




    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        On Error Resume Next
        Me.Visible = False
        boolViewDebug = False
        GotABotClass.subRedraw(tbpBotPose)
        Me.Close()
    End Sub

    Private Sub Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.FormClosing
        On Error Resume Next
        Me.Visible = False
        boolViewDebug = False
        GotABotClass.subRedraw(tbpBotPose)
    End Sub

    Private Sub Got_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.Paint
        On Error Resume Next
        rrtxtDebugLog.Width = Me.Width - 55
        rrtxtDebugLog.Height = Me.Height - 222
    End Sub


    Private Sub Zoom_MouseWheel(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles rrtxtDebugLog.MouseWheel
        On Error Resume Next
        If e.Delta <> 0 Then
            Me.Width += CInt(Me.Width * e.Delta / 1000)
            Me.Height += CInt(Me.Height * e.Delta / 1000)
            If e.Delta <= 0 Then
                If Me.Height < 300 Then Me.Height = 300 '
                If Me.Width < 600 Then Me.Width = 600 '
            Else
                If Me.Height > Screen.PrimaryScreen.Bounds.Height Then Me.Height = Screen.PrimaryScreen.Bounds.Height
                If Me.Width > Screen.PrimaryScreen.Bounds.Width Then Me.Width = Screen.PrimaryScreen.Bounds.Width
            End If
            Got_Resize(sender, e)
            subDoEventsIfMainThread()
            Me.Refresh()
        End If
    End Sub

    Private Sub ComZoom_MouseWheel(ByVal sender As System.Object, ByVal e As MouseEventArgs)
        Zoom_MouseWheel(sender, e)
    End Sub







    Private Sub butSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butSend.Click
        On Error Resume Next
        Me.subWriteLogs(Color.Green, Now() & "****** Debug Window User Generated Command :   " & txtCommand.Text)
        Dim strCommandText As String = txtCommand.Text & " 0 0 0 0 0 0"
        Dim strParsedText As String() = strCommandText.Split(" "c)
        If CBool(InStr(txtCommand.Text, "move")) And CBool(InStr(txtCommand.Text, " x ")) Then
            tbpStartingPose = tbpBotPose
            strTypeOfMove = "XY"
            Dim tbpTargetPose As typeBotPose
            tbpTargetPose.Location.X = ftnLocationFromEstimatedPose(tbpStartingPose, 0, Val(strParsedText(2))).X
            tbpTargetPose.Location.Y = ftnLocationFromEstimatedPose(tbpStartingPose, 90, Val(strParsedText(4))).Y
            tbpTargetPose.Orientation = ftnConvertTo360(tbpStartingPose.Orientation + Atan(Val(strParsedText(2)) / Val(strParsedText(4))))
            boolStop = False
            tbpBotPose = ftnExecuteMove(tbpBotPose, txtCommand.Text, tbpTargetPose)
        ElseIf CBool(InStr(txtCommand.Text, "move")) Then
            tbpStartingPose = tbpBotPose
            If CBool(InStr(txtCommand.Text, "degrees")) Then
                strTypeOfMove = "Turn"
            Else
                strTypeOfMove = "Fwd"
            End If
            Dim tbpTargetPose As typeBotPose = tbpBotPose
            If CBool(InStr(txtCommand.Text, "degrees")) Then  ' TODO Parse string and correct tbpTargetPose
                tbpTargetPose.Orientation = ftnConvertTo360(tbpStartingPose.Orientation + Val(strParsedText(1))) '
            Else
                tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpStartingPose, 0, Val(strParsedText(1))) '
            End If
            boolStop = False
            tbpBotPose = ftnExecuteMove(tbpBotPose, txtCommand.Text, tbpTargetPose)
        Else
            ftnSendCommand(txtCommand.Text)
        End If
    End Sub



    Private Sub frmDebug_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        GotABotClass.subRedraw(tbpBotPose)
    End Sub

    '====================================  Write Log Files  ===============================================================

    Public Sub subWriteMoveStartLogFile(ByVal strCommand As String, ByVal tbpTargetPose As typeBotPose)
        Try
            Dim strToWrite As String
            If Not GotABotClass.InvokeRequired And boolLogFileEnable Then
                strToWrite = vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf
                strToWrite = strToWrite & "===========  " & intDrivingSequenceNumber & " - " & Now() & "  =================================================" & vbCrLf
                strToWrite = strToWrite & "Bot Pose = " & tbpBotPose.Location.X & " " & tbpBotPose.Location.Y & "  +/- " & tbpBotPose.LocationUncertainty.X & " " & tbpBotPose.LocationUncertainty.Y & _
                             "      at " & Int(tbpBotPose.Orientation) & "  +/- " & Int(tbpBotPose.OrientationUncertainty) & " degrees" & vbCrLf
                strToWrite = strToWrite & "Driving Command =  " & strCommand & vbCrLf & vbCrLf
                strToWrite &= "Target = " & tbpTargetPose.Location.X & ", " & tbpTargetPose.Location.Y & " at " & tbpTargetPose.Orientation & " degrees." & vbCrLf
                subWriteStrToLogFile(strToWrite)
                System.Windows.Forms.Application.DoEvents()
            End If
        Catch ex As Exception
            subWriteLogs(Color.Green, " EXCEPTION in subWriteMoveStartLogFile")
        End Try
    End Sub

    Dim strCouldntWrite As String = ""
    Sub subWriteStrToLogFile(ByVal strToWrite As String)
        Try
            If Not GotABotClass.InvokeRequired And boolLogFileEnable Then
                strToWrite = strCouldntWrite & strToWrite
                My.Computer.FileSystem.WriteAllText(My.Application.Info.DirectoryPath & "\GotABot_Log.txt", strToWrite & vbCrLf, True)
                System.Windows.Forms.Application.DoEvents()
                strCouldntWrite = ""
            End If
        Catch
            strCouldntWrite = strToWrite & strCouldntWrite & vbCrLf
            System.Windows.Forms.Application.DoEvents()
        End Try
    End Sub

    Public Sub subDebugLog(ByVal colFont As Color, ByVal strtext As String)
        Try
            If Not GotABotClass.InvokeRequired Then
                If Me.Visible Then
                    If CBool(InStr(strtext, "vbCr")) Then _
                       strtext = strtext.Replace(vbCrLf, "") '  
                    Me.rrtxtDebugLog.AppendText(strtext)

                    Dim textEnd As Integer = rrtxtDebugLog.TextLength
                    Dim lastIndex As Integer = rrtxtDebugLog.Text.LastIndexOf(rrtxtDebugLog.Text)
                    Dim index As Integer = rrtxtDebugLog.TextLength - strtext.Length   'Kludge

                    rrtxtDebugLog.Find(strtext, index, textEnd, RichTextBoxFinds.WholeWord)
                    Me.rrtxtDebugLog.SelectionColor = colFont
                    Me.rrtxtDebugLog.BackColor = Color.White
                    Me.rrtxtDebugLog.AppendText(vbCrLf)
                    rrtxtDebugLog.SelectionStart = rrtxtDebugLog.TextLength       'Scroll
                    rrtxtDebugLog.ScrollToCaret()
                    Me.Refresh()
                    System.Windows.Forms.Application.DoEvents()
                End If
            End If
        Catch ex As Exception
            subWriteLogs(Color.Green, " EXCEPTION in subDebugLog")
        End Try
    End Sub

    Delegate Sub DelegateWriteLogs(ByVal colFont As Color, ByVal strtext As String)
    Public Sub subWriteLogs(ByVal colFont As Color, ByVal strtext As String)
        Try
            If GotABotClass.InvokeRequired Then
                Dim newDelegate As New DelegateWriteLogs(AddressOf subWriteLogs)
                GotABotClass.Invoke(newDelegate, New Object() {colFont, strtext})
                'System.Windows.Forms.Application.DoEvents()
            ElseIf boolLogFileEnable Then
                subDebugLog(colFont, strtext)
                subWriteStrToLogFile(strtext)
                'System.Windows.Forms.Application.DoEvents()
            End If
        Catch ex As Exception
            subWriteLogs(Color.Green, " EXCEPTION in subWriteLogs")
        End Try
    End Sub


    Public Sub subWriteFinishedMessage()
        Try
            subWriteLogs(Color.Black, "  ===============================================================================================  ")
            subWriteLogs(Color.Black, "    ")
            subWriteLogs(Color.Black, "    ")
            subWriteLogs(Color.Black, Now() & "  : " & intDrivingSequenceNumber & "    -----------------------------  Finished Driving.  ------------------------- ")
            subWriteLogs(Color.Black, "                          Elapsed Time = " & Now().Subtract(timeDrivingStarted).ToString & "    // Collisions = " & intCollisions)
            subWriteLogs(Color.Black, "    ")
            subWriteLogs(Color.Black, "    ")
            subWriteLogs(Color.Black, "  ===============================================================================================  ")
        Catch ex As Exception
            subWriteLogs(Color.Green, " EXCEPTION in subWriteFinishedMessage")
        End Try
    End Sub



    Public Sub subWritePoseIfVerbose(ByVal strIdentify As String, ByVal tbpWritePose As typeBotPose)
        If boolVerboseLogFile Then WritePose(strIdentify, tbpWritePose)
    End Sub

    Public Sub WritePose(ByVal strIdentify As String, ByVal tbpWritePose As typeBotPose)
        Try
            If Not GotABotClass.InvokeRequired Then
                Me.subWriteLogs(Color.Green, " ****** " & strIdentify & " = " & tbpWritePose.Location.X & ", " & tbpWritePose.Location.Y _
                             & " +/- " & tbpWritePose.LocationUncertainty.X & ", " & tbpWritePose.LocationUncertainty.Y _
                             & " at " & CShort(tbpWritePose.Orientation) & " +/- " & CShort(tbpWritePose.OrientationUncertainty) & " degrees")
            End If
        Catch ex As Exception
            subWriteLogs(Color.Green, " EXCEPTION in WritePose")
        End Try
    End Sub

End Class