﻿Public Class frmRangeFinder

    Public Sub FinderInitialize()
        On Error Resume Next
        Me.Visible = True
        btnEnable1.Checked = trfRangeFinders(updnFinderNumber.Value).boolEnable
        updnOffsetX.Value = trfRangeFinders(updnFinderNumber.Value).intOffset.X
        updnOffsetY.Value = trfRangeFinders(updnFinderNumber.Value).intOffset.Y
        updnOrientation.Value = trfRangeFinders(updnFinderNumber.Value).intOrientation
        trbRangeCalibrate.Value = trfRangeFinders(updnFinderNumber.Value).intCalibrate
        boolRangersAreEnabled = ftnRangersAreEnabled()
        txtMax.Text = "0"
        txtMin.Text = "9999"
        txtAvg.Text = "0"
        intRangeSample = 0
        sngRangeAverage = 0
        txtSample.Text = "0"
    End Sub

    Private Sub updnFinderNumber_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnFinderNumber.ValueChanged
        On Error Resume Next
        btnEnable1.Checked = trfRangeFinders(updnFinderNumber.Value).boolEnable
        updnOffsetX.Value = trfRangeFinders(updnFinderNumber.Value).intOffset.X
        updnOffsetY.Value = trfRangeFinders(updnFinderNumber.Value).intOffset.Y
        updnOrientation.Value = trfRangeFinders(updnFinderNumber.Value).intOrientation
        trbRangeCalibrate.Value = trfRangeFinders(updnFinderNumber.Value).intCalibrate
        txtMax.Text = "0"
        txtMin.Text = "9999"
        txtAvg.Text = "0"
        intRangeSample = 0
        sngRangeAverage = 0
        txtSample.Text = "0"
    End Sub

    Private Sub btnEnable1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnable1.MouseClick
        On Error Resume Next
        btnEnable1.Checked = Not trfRangeFinders(updnFinderNumber.Value).boolEnable
        trfRangeFinders(updnFinderNumber.Value).boolEnable = btnEnable1.Checked
        boolSettingsChanged = True
        boolRangersAreEnabled = ftnRangersAreEnabled()
    End Sub

    Private Sub updnOffsetX_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnOffsetX.Click
        On Error Resume Next
        trfRangeFinders(updnFinderNumber.Value).intOffset.X = updnOffsetX.Value
        boolSettingsChanged = True
    End Sub

    Private Sub updnOffsetX_ValueChanged_1(sender As System.Object, e As System.EventArgs) Handles updnOffsetX.ValueChanged
        On Error Resume Next
        trfRangeFinders(updnFinderNumber.Value).intOffset.X = updnOffsetX.Value
        boolSettingsChanged = True
    End Sub

    Private Sub updnOffsetY_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnOffsetY.Click
        trfRangeFinders(updnFinderNumber.Value).intOffset.Y = updnOffsetY.Value
        boolSettingsChanged = True
    End Sub

    Private Sub updnOffsetY_ValueChanged_1(sender As System.Object, e As System.EventArgs) Handles updnOffsetY.ValueChanged
        On Error Resume Next
        trfRangeFinders(updnFinderNumber.Value).intOffset.Y = updnOffsetY.Value
        boolSettingsChanged = True
    End Sub

    Private Sub updnOrientation_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnOrientation.Click
        On Error Resume Next
        trfRangeFinders(updnFinderNumber.Value).intOrientation = updnOrientation.Value
        boolSettingsChanged = True
    End Sub

    Private Sub updnOrientation_ValueChanged_1(sender As System.Object, e As System.EventArgs) Handles updnOrientation.ValueChanged
        On Error Resume Next
        trfRangeFinders(updnFinderNumber.Value).intOrientation = updnOrientation.Value
        boolSettingsChanged = True
    End Sub

    Private Sub trbRangeCalibrate_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trbRangeCalibrate.Scroll
        On Error Resume Next
        trfRangeFinders(updnFinderNumber.Value).intCalibrate = trbRangeCalibrate.Value
        boolSettingsChanged = True
    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        On Error Resume Next
        Me.Visible = False
        strStatusDriving = ""
        GotABotClass.subRedraw(tbpBotPose)
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        On Error Resume Next
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Dim tbpTempPose As typeBotPose = tbpBotPose ' make sure we aren't throwing away important stuff!
        Dim tlmTempLandMarkArray(128) As typeLandMark
        tlmTempLandMarkArray = tlmLandMarkArray
        GotABotClass.mnuLoadSettings_Click(trfRangeFinders, e)
        tbpBotPose = tbpTempPose
        tlmLandMarkArray = tlmTempLandMarkArray
        strStatusDriving = ""
        GotABotClass.subRedraw(tbpBotPose)
        Me.Close()
    End Sub

    Public Function ftnRangersAreEnabled() As Boolean
        On Error Resume Next
        ftnRangersAreEnabled = False
        intNumberOfEnabledRangers = 0
        For intRangerNumber As Short = 1 To intHighestEnabledRangerNumber ' For each Range Finder
            If trfRangeFinders(intRangerNumber).boolEnable Then
                intNumberOfEnabledRangers += 1
                ftnRangersAreEnabled = boolER1Selected
            End If
        Next intRangerNumber
    End Function

    Dim sngRangeAverage As Single = 0
    Dim intRangeSample As Short = 0
    Private Sub subUpdateRangeDisplay()
        On Error Resume Next
        Dim trvRangeVector, trvRangeVectorFromCenter As typeRangeVector
        While Me.Visible And Not boolShutDown
            trvRangeVector.sngRange = ftnRangeFinderRange(updnFinderNumber.Value)
            trvRangeVector.sngAngle = trfRangeFinders(updnFinderNumber.Value).intOrientation
            txtRange.Text = trvRangeVector.sngRange.ToString
            txtSample.Text = intRangeSample.ToString
            If (trvRangeVector.sngRange > Val(txtMax.Text)) Then txtMax.Text = trvRangeVector.sngRange.ToString
            If (trvRangeVector.sngRange < Val(txtMin.Text)) Then txtMin.Text = trvRangeVector.sngRange.ToString
            sngRangeAverage = (sngRangeAverage * intRangeSample + trvRangeVector.sngRange) / (intRangeSample + 1)
            txtAvg.Text = sngRangeAverage.ToString
            intRangeSample += 1
            trvRangeVectorFromCenter = ftnRangeFinderVector(tbpBotPose, updnFinderNumber.Value, trvRangeVector.sngRange, trvRangeVector.sngAngle) ' Find Range vector - relative to Bot center
            If Not (GotABotClass.FileToolStripMenuItem1.Selected Or GotABotClass.FileToolStripMenuItem1.Pressed _
                 Or GotABotClass.mnuConfigure.Selected _
                 Or GotABotClass.mnuTools.Selected Or GotABotClass.mnuTools.Pressed _
                 Or GotABotClass.HelpToolStripMenuItem1.Selected Or GotABotClass.HelpToolStripMenuItem1.Pressed _
                 Or GotABotClass.updnOrientation.Focused) Then
                If Not boolSlam Then GotABotClass.subRedraw(tbpBotPose)
                If Me.Visible Then subDrawVectorFromBot(tbpBotPose, trvRangeVectorFromCenter.sngRange, trvRangeVectorFromCenter.sngAngle, True) ' Show Range Vector on map
            End If
            subDoEventsIfMainThread()
        End While
        GotABotClass.subRedraw(tbpBotPose)
    End Sub


    Private Sub frmRangeFinder_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        On Error Resume Next
        If GotABotClass.Visible Then
            strStatusDriving = ""
            FinderInitialize()
            GotABotClass.subRedraw(tbpBotPose)
            subUpdateRangeDisplay()
        End If
    End Sub




    '==================================================  Get Ranger Readings  ===============================================

    Sub subGetRangerReadings()
        On Error Resume Next
        If boolRangersAreEnabled And boolER1Selected And Not boolRangeReadingsAreFresh Then
            If boolEnableRangerAveraging Then
                subGetAllRangerAvgReadingsER1(4)
            Else
                subGetAllRangerReadingsER1()
            End If
            If Not boolBotIsMoving Then boolRangeReadingsAreFresh = True
        End If
    End Sub

    Public Sub subGetAllRangerReadingsER1()
        On Error Resume Next
        If boolEnableEvolutionIR_ER1 Then
            subGetEvolutionIRsRange()
        Else
            Dim intRangerNumber As Short
            Dim strCommand As String = "input analog "
            For intRangerNumber = 1 To 14 ' make a list of enabled Range Finders
                If trfRangeFinders(intRangerNumber).boolEnable Then
                    strCommand = strCommand & (intRangerNumber - 1).ToString & " "
                End If
            Next intRangerNumber

            Dim strRecved As String  ' get the range finder raw data
            strRecved = ftnSendCommand(strCommand)
            If boolVerboseLogFile Then frmDebug.subWriteLogs(Color.DarkGray, Now() & " $$$$$$$$$$$$$$$$$$$$$$$  Analog Received = " & strRecved)
            subDoEventsIfMainThread()

            Dim strParsedText As String()
            strParsedText = strRecved.Split(" "c)
            Dim intAnalogReading As Integer
            Dim intAnalogNumber As Integer = 0
            For intRangerNumber = 1 To 14 ' extract the range data
                If trfRangeFinders(intRangerNumber).boolEnable And boolER1Selected Then
                    If (UBound(strParsedText) >= intAnalogNumber) Then
                        If Val(strParsedText(intAnalogNumber)) >= 0 Then
                            intAnalogReading = Val(strParsedText(intAnalogNumber))
                            trfRangeFinders(intRangerNumber).sngRange = ftnAnalogToRange(intRangerNumber, intAnalogReading)
                        End If
                        intAnalogNumber += 1
                    Else
                        trfRangeFinders(intRangerNumber).sngRange = ftnCmToMapUnits(constIR_MaxRange)
                    End If
                End If
            Next intRangerNumber
        End If
    End Sub

    Public Sub subGetAllRangerAvgReadingsER1(ByVal intNumberOfSamples As Short)
        On Error Resume Next
        Dim sngAvgRange(intHighestEnabledRangerNumber) As Single
        For intSampleNumber As Short = 1 To intNumberOfSamples
            If boolStop Then Exit Sub
            subGetAllRangerReadingsER1()
            For intRangerNumber = 1 To intHighestEnabledRangerNumber
                If trfRangeFinders(intRangerNumber).boolEnable Then sngAvgRange(intRangerNumber) += trfRangeFinders(intRangerNumber).sngRange
            Next intRangerNumber
        Next intSampleNumber
        For intRangerNumber = 1 To 14
            If Not boolBotConnected Then
                subDoEventsIfMainThread()
                trfRangeFinders(intRangerNumber).sngRange = trfRangeFinders(intRangerNumber).sngMaxRange
            Else
                If trfRangeFinders(intRangerNumber).boolEnable Then
                    trfRangeFinders(intRangerNumber).sngRange = sngAvgRange(intRangerNumber) / intNumberOfSamples
                    If boolVerboseLogFile Then _
                        frmDebug.subWriteLogs(Color.DarkGray, " RangeFinder No " & intRangerNumber & ":  Range = " & trfRangeFinders(intRangerNumber).sngRange.ToString & " ,  Orientation = " & trfRangeFinders(intRangerNumber).intOrientation.ToString)
                End If
            End If
        Next intRangerNumber
    End Sub


    Public Function ftnRangeFinderRange(ByVal intRangerNumber As Short) As Single
        On Error Resume Next
        If Not boolBotConnected Then
            strStatusDriving = ":  WARNING - Bot not connected"
            GotABotClass.subUpdateStatusLine()
            subDoEventsIfMainThread()
            ftnRangeFinderRange = ftnCmToMapUnits(trfRangeFinders(intRangerNumber).sngMaxRange)
        ElseIf boolEnableEvolutionIR_ER1 Then
            subGetEvolutionIRsRange()
            ftnRangeFinderRange = trfRangeFinders(intRangerNumber).sngRange
            If boolVerboseLogFile Then frmDebug.subWriteLogs(Color.DarkGray, " RangeFinder No " & intRangerNumber & ":  Range = " & ftnRangeFinderRange.ToString & " ,  Orientation = " & trfRangeFinders(intRangerNumber).intOrientation.ToString)
            subDoEventsIfMainThread()
        Else
            If (intRangerNumber < 15) And (intRangerNumber > 0) Then
                ftnSendCommand("input analog " & (intRangerNumber - 1).ToString)   ' Get the Range Finder reading
                ftnRangeFinderRange = ftnAnalogToRange(intRangerNumber, intAnalogReading)
            Else
                ftnRangeFinderRange = trfRangeFinders(intRangerNumber).sngRange
            End If
            If boolVerboseLogFile Then frmDebug.subWriteLogs(Color.DarkGray, " RangeFinder No " & intRangerNumber & ":  Range = " & ftnRangeFinderRange.ToString & " ,  Orientation = " & trfRangeFinders(intRangerNumber).intOrientation.ToString)
            subDoEventsIfMainThread()
        End If
    End Function

    Sub subGetEvolutionIRsRange()
        On Error Resume Next
        Dim strResponse As String = ftnER1_Communicate("ir all ", "OK", 1000) & " 0 0 0 0 0 0 0 0 0 0 0 0"
        Dim strParsedText As String() = strResponse.Split(" "c)
        For intRangerNumber = 1 To 3
            trfRangeFinders(intRangerNumber).sngRange = ftnCmToMapUnits(266 - 2.67 * Val(strParsedText(intRangerNumber * 3 - 2))) * trfRangeFinders(intRangerNumber).intCalibrate / 50
        Next intRangerNumber
    End Sub


    Public Function ftnAnalogToRange(ByVal intRangerNumber As Short, ByVal intAnalogReading As Integer) As Single
        On Error Resume Next
        ftnAnalogToRange = (trfRangeFinders(intRangerNumber).intCalibrate * 0.02) * 2283761.3 * (intAnalogReading ^ -1.2014)
        If ftnAnalogToRange > trfRangeFinders(intRangerNumber).sngMaxRange Then ftnAnalogToRange = trfRangeFinders(intRangerNumber).sngMaxRange
        ftnAnalogToRange = ftnCmToMapUnits(ftnAnalogToRange)
    End Function



    Public Function ftnRangeFinderVector(ByVal tbpEstimatedPose As typeBotPose, ByVal intRangerNumber As Short, ByVal sngRange As Single, ByVal sngRelativeAngle As Single) As typeRangeVector  ' convert the Range Finder information to a vector relative to the center of the Bot
        On Error Resume Next
        Dim trvRangeVector As typeRangeVector
        trvRangeVector.sngAngle = sngRelativeAngle
        trvRangeVector.sngRange = sngRange
        Dim tmcRangerPose As typeBotPose = tbpEstimatedPose
        tmcRangerPose.Location = ftnLocationFromEstimatedPose(tbpEstimatedPose, trfRangeFinders(intRangerNumber).intOffset)
        Dim tmcEndPoint As typeMapCoordinate = ftnLocationFromEstimatedPose(tmcRangerPose, trvRangeVector)
        ftnRangeFinderVector.sngRange = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tmcEndPoint)
        ftnRangeFinderVector.sngAngle = ftnConvertTo180(ftnP1ToP2Angle(tbpEstimatedPose.Location, tmcEndPoint) - tbpBotPose.Orientation)
    End Function







End Class