﻿
Imports System
Imports System.Xml
Imports System.Xml.Serialization
Imports System.IO
Imports System.Net
Imports System.Text

Module modRSS_Reader

    ' code taken from http://forums.asp.net/t/1160518.aspx/1
    Public Function ftnGetWeatherRSS(ByVal rssURL As String) As String
        On Error Resume Next
        ftnGetWeatherRSS = ""
        Dim request As WebRequest = WebRequest.Create(rssURL)
        Dim response As WebResponse = request.GetResponse()
        Dim rssStream As Stream = response.GetResponseStream()
        Dim rssDoc As New XmlDocument()
        rssDoc.Load(rssStream)
        'MessageBox.Show(rssDoc.OuterXml)
        rssDoc.Save("weather.xml")
        Dim rssItems As XmlNodeList = rssDoc.SelectNodes("rss/channel/item")
        ftnGetWeatherRSS = rssItems.Item(0).SelectSingleNode("title").InnerText & ".  "
        ftnGetWeatherRSS &= " Present conditions are " & rssDoc.GetElementsByTagName("yweather:condition").Item(0).Attributes.GetNamedItem("text").Value & ",  "
        ftnGetWeatherRSS &= " with a temperature of " & rssDoc.GetElementsByTagName("yweather:condition").Item(0).Attributes.GetNamedItem("temp").Value & " degrees,  "
        ftnGetWeatherRSS &= " and a high of   " & rssDoc.GetElementsByTagName("yweather:forecast").Item(0).Attributes.GetNamedItem("high").Value & " degrees today.  "
        ftnGetWeatherRSS &= " Tomorrow will be  " & rssDoc.GetElementsByTagName("yweather:forecast").Item(1).Attributes.GetNamedItem("text").Value & ",  "
        ftnGetWeatherRSS &= " with an expected high of   " & rssDoc.GetElementsByTagName("yweather:forecast").Item(1).Attributes.GetNamedItem("high").Value & " degrees.  "
    End Function
End Module
